Skip to content
Projects
Groups
Snippets
Help
Loading...
Help
Support
Keyboard shortcuts
?
Submit feedback
Contribute to GitLab
Sign in / Register
Toggle navigation
C
cython
Project overview
Project overview
Details
Activity
Releases
Repository
Repository
Files
Commits
Branches
Tags
Contributors
Graph
Compare
Labels
Merge Requests
0
Merge Requests
0
Analytics
Analytics
Repository
Value Stream
Snippets
Snippets
Members
Members
Collapse sidebar
Close sidebar
Activity
Graph
Commits
Open sidebar
nexedi
cython
Commits
4ea8e68c
Commit
4ea8e68c
authored
Jul 13, 2021
by
Stefane Fermigier
Browse files
Options
Browse Files
Download
Email Patches
Plain Diff
Use github's CI.
parent
fd3a2244
Changes
2
Show whitespace changes
Inline
Side-by-side
Showing
2 changed files
with
414 additions
and
0 deletions
+414
-0
.github/workflows/ci.yml
.github/workflows/ci.yml
+289
-0
Tools/ci-run.sh
Tools/ci-run.sh
+125
-0
No files found.
.github/workflows/ci.yml
0 → 100644
View file @
4ea8e68c
name
:
CI
on
:
[
push
,
pull_request
]
jobs
:
ci
:
strategy
:
# Allows for matrix sub-jobs to fail without canceling the rest
fail-fast
:
false
# MATRIX:
# =======
# Required parameters:
# os the os to run on
# python-version the python version to use
# backend the backend to use
# env any additional env variables. Set to '{}' for none
# Optional parameters:
# allowed_failure whether the job is allowed to fail
# extra_hash extra hash str to differentiate from other caches with similar name (must always start with '-')
matrix
:
# Tests [amd64]
#
# FIXME: 'cpp' tests seems to fail due to compilation errors (numpy_pythran_unit)
# in all python versions and test failures (builtin_float) in 3.5<
os
:
[
ubuntu-18.04
]
backend
:
[
c
,
cpp
]
python-version
:
[
2.7
,
3.4
,
3.5
,
3.6
,
3.7
,
3.8
,
3.9
,
3.10-dev
]
env
:
[{}]
include
:
# Temporary - Allow failure on all Python -dev jobs until they are considered stable
#- python-version: 3.10-dev
# allowed_failure: true
# Ubuntu sub-jobs:
# ================
# GCC 11
-
os
:
ubuntu-18.04
python-version
:
3.9
backend
:
c
env
:
{
GCC_VERSION
:
11
}
extra_hash
:
"
-gcc11"
-
os
:
ubuntu-18.04
python-version
:
3.9
backend
:
cpp
env
:
{
GCC_VERSION
:
11
}
extra_hash
:
"
-gcc11"
# Linting
-
os
:
ubuntu-18.04
python-version
:
3.7
backend
:
"
c,cpp"
env
:
{
TEST_CODE_STYLE
:
1
,
NO_CYTHON_COMPILE
:
1
}
extra_hash
:
"
-codestyle"
# Limited API
-
os
:
ubuntu-18.04
python-version
:
3.6
backend
:
"
c,cpp"
env
:
{
LIMITED_API
:
"
--limited-api"
,
EXCLUDE
:
"
--no-file"
}
extra_hash
:
"
-limited_api"
-
os
:
ubuntu-18.04
python-version
:
3.7
backend
:
"
c,cpp"
env
:
{
LIMITED_API
:
"
--limited-api"
,
EXCLUDE
:
"
--no-file"
}
extra_hash
:
"
-limited_api"
-
os
:
ubuntu-18.04
python-version
:
3.8
backend
:
"
c,cpp"
env
:
{
LIMITED_API
:
"
--limited-api"
,
EXCLUDE
:
"
--no-file"
}
extra_hash
:
"
-limited_api"
# Type specs
-
os
:
ubuntu-18.04
python-version
:
3.9
backend
:
c
env
:
{
EXTRA_CFLAGS
:
"
-DCYTHON_USE_TYPE_SPECS=1"
}
extra_hash
:
"
-typespecs"
-
os
:
ubuntu-18.04
python-version
:
3.8
backend
:
c
env
:
{
EXTRA_CFLAGS
:
"
-DCYTHON_USE_TYPE_SPECS=1"
}
extra_hash
:
"
-typespecs"
-
os
:
ubuntu-18.04
python-version
:
3.7
backend
:
c
env
:
{
EXTRA_CFLAGS
:
"
-DCYTHON_USE_TYPE_SPECS=1"
}
extra_hash
:
"
-typespecs"
-
os
:
ubuntu-18.04
python-version
:
3.6
backend
:
c
env
:
{
EXTRA_CFLAGS
:
"
-DCYTHON_USE_TYPE_SPECS=1"
}
extra_hash
:
"
-typespecs"
-
os
:
ubuntu-18.04
python-version
:
3.5
backend
:
c
env
:
{
EXTRA_CFLAGS
:
"
-DCYTHON_USE_TYPE_SPECS=1"
}
extra_hash
:
"
-typespecs"
allowed_failure
:
true
# Stackless
-
os
:
ubuntu-18.04
python-version
:
2.7
backend
:
c
env
:
{
STACKLESS
:
true
,
PY
:
2
}
extra_hash
:
"
-stackless"
-
os
:
ubuntu-18.04
python-version
:
3.6
backend
:
c
env
:
{
STACKLESS
:
true
,
PY
:
3
}
extra_hash
:
"
-stackless"
# Pypy
-
os
:
ubuntu-18.04
python-version
:
pypy-2.7
backend
:
c
env
:
{
NO_CYTHON_COMPILE
:
1
}
-
os
:
ubuntu-18.04
python-version
:
pypy-3.7
backend
:
c
env
:
{
NO_CYTHON_COMPILE
:
1
}
# Pypy [allowed-failures] - These specifically test known bugs
-
os
:
ubuntu-18.04
python-version
:
pypy-2.7
backend
:
c
env
:
{
NO_CYTHON_COMPILE
:
1
,
EXCLUDE
:
"
--listfile=tests/pypy_bugs.txt
--listfile=tests/pypy2_bugs.txt
bugs"
,
}
allowed_failure
:
true
extra_hash
:
"
-allowed_failures"
-
os
:
ubuntu-18.04
python-version
:
pypy-3.7
backend
:
c
env
:
{
NO_CYTHON_COMPILE
:
1
,
EXCLUDE
:
"
--listfile=tests/pypy_bugs.txt
bugs"
}
allowed_failure
:
true
extra_hash
:
"
-allowed_failures"
# Coverage - Disabled due to taking too long to run
# - os: ubuntu-18.04
# python-version: 3.7
# backend: "c,cpp"
# env: { COVERAGE: 1 }
# extra_hash: '-coverage'
# MacOS sub-jobs
# ==============
# (C-only builds are used to create wheels)
-
os
:
macos-10.15
python-version
:
2.7
backend
:
c
env
:
{
MACOSX_DEPLOYMENT_TARGET
:
10.14
}
-
os
:
macos-10.15
python-version
:
2.7
backend
:
cpp
env
:
{
MACOSX_DEPLOYMENT_TARGET
:
10.14
}
-
os
:
macos-10.15
python-version
:
3.5
backend
:
c
env
:
{
MACOSX_DEPLOYMENT_TARGET
:
10.14
}
-
os
:
macos-10.15
python-version
:
3.6
backend
:
c
env
:
{
MACOSX_DEPLOYMENT_TARGET
:
10.14
}
-
os
:
macos-10.15
python-version
:
3.7
backend
:
c
env
:
{
MACOSX_DEPLOYMENT_TARGET
:
10.14
}
-
os
:
macos-10.15
python-version
:
3.8
backend
:
c
env
:
{
MACOSX_DEPLOYMENT_TARGET
:
10.14
}
-
os
:
macos-10.15
python-version
:
3.9
backend
:
c
env
:
{
MACOSX_DEPLOYMENT_TARGET
:
10.14
}
-
os
:
macos-10.15
python-version
:
3.9
backend
:
cpp
env
:
{
MACOSX_DEPLOYMENT_TARGET
:
10.14
}
# This defaults to 360 minutes (6h) which is way too long and if a test gets stuck, it can block other pipelines.
# From testing, the runs tend to take ~20 minutes, so a limit of 30 minutes should be enough. This can always be
# changed in the future if needed.
timeout-minutes
:
30
runs-on
:
${{ matrix.os }}
env
:
BACKEND
:
${{ matrix.backend }}
OS_NAME
:
${{ matrix.os }}
PYTHON_VERSION
:
${{ matrix.python-version }}
GCC_VERSION
:
8
USE_CCACHE
:
1
CCACHE_SLOPPINESS
:
"
pch_defines,time_macros"
CCACHE_COMPRESS
:
1
CCACHE_MAXSIZE
:
"
200M"
steps
:
-
name
:
Checkout repo
uses
:
actions/checkout@v2
with
:
fetch-depth
:
1
-
name
:
Setup python
uses
:
actions/setup-python@v2
with
:
python-version
:
${{ matrix.python-version }}
-
name
:
Cache [ccache]
uses
:
pat-s/always-upload-cache@v2.1.3
if
:
startsWith(runner.os, 'Linux')
with
:
path
:
~/.ccache
key
:
${{ runner.os }}-ccache${{ matrix.extra_hash }}-${{ matrix.python-version }}-${{ matrix.backend == 'c' || matrix.backend == 'c,cpp' }}-${{ contains(matrix.backend, 'cpp') }}-${{ hashFiles('**/test-requirements*.txt', '**/ci.yml', '**/ci-run.sh') }}
-
name
:
Run CI
continue-on-error
:
${{ matrix.allowed_failure ||
false
}}
env
:
${{ matrix.env }}
run
:
bash ./Tools/ci-run.sh
-
name
:
Upload HTML docs
uses
:
actions/upload-artifact@v2
with
:
name
:
htmldocs
path
:
docs/build/html
if-no-files-found
:
ignore
-
name
:
Upload wheels
uses
:
actions/upload-artifact@v2
with
:
name
:
wheels-${{ runner.os }}
path
:
dist/*.whl
if-no-files-found
:
ignore
pycoverage
:
runs-on
:
ubuntu-18.04
env
:
BACKEND
:
c,cpp
OS_NAME
:
ubuntu-18.04
PYTHON_VERSION
:
3.9
steps
:
-
name
:
Checkout repo
uses
:
actions/checkout@v2
with
:
fetch-depth
:
1
-
name
:
Setup python
uses
:
actions/setup-python@v2
with
:
python-version
:
3.9
-
name
:
Run Coverage
env
:
{
COVERAGE
:
1
,
NO_CYTHON_COMPILE
:
1
}
run
:
bash ./Tools/ci-run.sh
-
name
:
Upload Coverage Report
uses
:
actions/upload-artifact@v2
with
:
name
:
pycoverage_html
path
:
coverage-report-html
# cycoverage:
# runs-on: ubuntu-18.04
#
# env:
# BACKEND: c,cpp
# OS_NAME: ubuntu-18.04
# PYTHON_VERSION: 3.9
#
# steps:
# - name: Checkout repo
# uses: actions/checkout@v2
# with:
# fetch-depth: 1
#
# - name: Setup python
# uses: actions/setup-python@v2
# with:
# python-version: 3.9
#
# - name: Run Coverage
# env: { COVERAGE: 1 }
# run: bash ./Tools/ci-run.sh
#
# - name: Upload Coverage Report
# uses: actions/upload-artifact@v2
# with:
# name: cycoverage_html
# path: coverage-report-html
Tools/ci-run.sh
0 → 100755
View file @
4ea8e68c
#!/usr/bin/bash
GCC_VERSION
=
${
GCC_VERSION
:
=8
}
# Set up compilers
if
[
"
${
OS_NAME
##ubuntu*
}
"
==
""
-a
"
$TEST_CODE_STYLE
"
!=
"1"
]
;
then
echo
"Installing requirements [apt]"
sudo
apt-add-repository
-y
"ppa:ubuntu-toolchain-r/test"
sudo
apt update
-y
-q
sudo
apt
install
-y
-q
ccache gdb python-dbg python3-dbg gcc-
$GCC_VERSION
||
exit
1
if
[
-z
"
${
BACKEND
##*cpp*
}
"
]
;
then
sudo
apt
install
-y
-q
g++-
$GCC_VERSION
||
exit
1
fi
sudo
/usr/sbin/update-ccache-symlinks
echo
"/usr/lib/ccache"
>>
$GITHUB_PATH
# export ccache to path
sudo
update-alternatives
--install
/usr/bin/gcc gcc /usr/bin/gcc-
$GCC_VERSION
60
$(
if
[
-z
"
${
BACKEND
##*cpp*
}
"
]
;
then
echo
" --slave /usr/bin/g++ g++ /usr/bin/g++-
$GCC_VERSION
"
;
fi
)
export
CC
=
"gcc"
if
[
-z
"
${
BACKEND
##*cpp*
}
"
]
;
then
sudo
update-alternatives
--set
g++ /usr/bin/g++-
$GCC_VERSION
export
CXX
=
"g++"
fi
fi
if
[
"
${
OS_NAME
##macos*
}
"
==
""
]
;
then
export
CC
=
"clang -Wno-deprecated-declarations"
export
CXX
=
"clang++ -stdlib=libc++ -Wno-deprecated-declarations"
fi
# Set up miniconda
if
[
"
$STACKLESS
"
==
"true"
]
;
then
echo
"Installing stackless python"
#conda install --quiet --yes nomkl --file=test-requirements.txt --file=test-requirements-cpython.txt
conda config
--add
channels stackless
conda
install
--quiet
--yes
stackless
||
exit
1
fi
# Log versions in use
echo
"===================="
echo
"|VERSIONS INSTALLED|"
echo
"===================="
python
-c
'import sys; print("Python %s" % (sys.version,))'
if
[
"
$CC
"
]
;
then
which
${
CC
%% *
}
${
CC
%% *
}
--version
fi
if
[
"
$CXX
"
]
;
then
which
${
CXX
%% *
}
${
CXX
%% *
}
--version
fi
echo
"===================="
# Install python requirements
echo
"Installing requirements [python]"
if
[
-z
"
${
PYTHON_VERSION
##2.7
}
"
]
;
then
pip
install
-r
test-requirements-27.txt
||
exit
1
elif
[
-z
"
${
PYTHON_VERSION
##3.[45]*
}
"
]
;
then
python
-m
pip
install
-r
test-requirements-34.txt
||
exit
1
else
python
-m
pip
install
-U
pip setuptools wheel
||
exit
1
if
[
-n
"
${
PYTHON_VERSION
##*-dev
}
"
]
;
then
python
-m
pip
install
-r
test-requirements.txt
||
exit
1
if
[
"
${
PYTHON_VERSION
##pypy*
}
"
-a
"
${
PYTHON_VERSION
##3.[4789]*
}
"
]
;
then
python
-m
pip
install
-r
test-requirements-cpython.txt
||
exit
1
fi
fi
fi
if
[
"
$TEST_CODE_STYLE
"
==
"1"
]
;
then
STYLE_ARGS
=
"--no-unit --no-doctest --no-file --no-pyregr --no-examples"
;
python
-m
pip
install
-r
doc-requirements.txt
||
exit
1
else
STYLE_ARGS
=
"--no-code-style"
;
# Install more requirements
if
[
-n
"
${
PYTHON_VERSION
##*-dev
}
"
]
;
then
if
[
-z
"
${
BACKEND
##*cpp*
}
"
]
;
then
echo
"WARNING: Currently not installing pythran due to compatibility issues"
# python -m pip install pythran==0.9.5 || exit 1
fi
if
[
"
$BACKEND
"
!=
"cpp"
-a
-n
"
${
PYTHON_VERSION
##pypy*
}
"
-a
-n
"
${
PYTHON_VERSION
##2*
}
"
-a
-n
"
${
PYTHON_VERSION
##*3.4
}
"
]
;
then
python
-m
pip
install
mypy
||
exit
1
fi
fi
fi
# Run tests
ccache
-s
2>/dev/null
||
true
export
PATH
=
"/usr/lib/ccache:
$PATH
"
if
[
"
$NO_CYTHON_COMPILE
"
!=
"1"
-a
-n
"
${
PYTHON_VERSION
##pypy*
}
"
]
;
then
CFLAGS
=
"-O2 -ggdb -Wall -Wextra
$(
python
-c
'import sys; print("-fno-strict-aliasing" if sys.version_info[0] == 2 else "")'
)
"
\
python setup.py build_ext
-i
\
$(
if
[
"
$COVERAGE
"
==
"1"
]
;
then
echo
" --cython-coverage"
;
fi
)
\
$(
python
-c
'import sys; print("-j5" if sys.version_info >= (3,5) else "")'
)
\
||
exit
1
fi
if
[
"
$TEST_CODE_STYLE
"
==
"1"
]
;
then
make
-C
docs html
||
exit
1
elif
[
-n
"
${
PYTHON_VERSION
##pypy*
}
"
]
;
then
# Run the debugger tests in python-dbg if available (but don't fail, because they currently do fail)
PYTHON_DBG
=
"python
$(
python
-c
'import sys; print("%d.%d" % sys.version_info[:2])'
)
-dbg"
if
$PYTHON_DBG
-V
>
&2
;
then
CFLAGS
=
"-O0 -ggdb"
$PYTHON_DBG
runtests.py
-vv
--no-code-style
Debugger
--backends
=
$BACKEND
;
fi
;
fi
export
CFLAGS
=
"-O0 -ggdb -Wall -Wextra
$EXTRA_CFLAGS
"
python runtests.py
\
-vv
$STYLE_ARGS
\
-x
Debugger
\
--backends
=
$BACKEND
\
$LIMITED_API
\
$EXCLUDE
\
$(
if
[
"
$COVERAGE
"
==
"1"
]
;
then
echo
" --coverage --coverage-html --cython-only"
;
fi
)
\
$(
if
[
-z
"
$TEST_CODE_STYLE
"
]
;
then
echo
" -j7 "
;
fi
)
EXIT_CODE
=
$?
ccache
-s
2>/dev/null
||
true
exit
$EXIT_CODE
Write
Preview
Markdown
is supported
0%
Try again
or
attach a new file
Attach a file
Cancel
You are about to add
0
people
to the discussion. Proceed with caution.
Finish editing this message first!
Cancel
Please
register
or
sign in
to comment